import 'dart:async';
// In order to *not* need this ignore, consider extracting the "web" version
// of your plugin as a separate package, instead of inlining it in the same
// package as the core of your plugin.
// ignore: avoid_web_libraries_in_flutter
import 'dart:html' as html;
import 'package:flutter/services.dart';
import 'package:flutter_web_plugins/flutter_web_plugins.dart';
import 'package:csounddart/csound.dart';

/// A web implementation of the Csounddart plugin.
class CsounddartWeb {
  static void registerWith(Registrar registrar) {
    final MethodChannel channel = MethodChannel(
      'csounddart',
      const StandardMethodCodec(),
      registrar,
    );

    print("trying to load csoundobj");
    html.ScriptElement csObj = html.ScriptElement()
      ..src = "assets/packages/csounddart/assets/CsoundObj.js"
      ..type = "text/javascript "
      ..async = false
      ..defer = false;

    csObj.onLoad.lastWhere((element) {
      print("Loading CsoundDart");
      html.document.head!.append(html.ScriptElement()
        ..src = "assets/packages/csounddart/assets/CsoundDart.js"
        ..type = "module"
        ..async = true
        ..defer = true);

      print("Csound Dart load command done");
      return true;
    });

    html.document.head!.append(csObj);


    final pluginInstance = CsounddartWeb();
    channel.setMethodCallHandler(pluginInstance.handleMethodCall);
  }

  /// Handles method calls over the MethodChannel of this plugin.
  /// Note: Check the "federated" architecture for a new way of doing this:
  /// https://flutter.dev/go/federated-plugins
  Future<dynamic> handleMethodCall(MethodCall call) async {
    switch (call.method) {
      case 'getPlatformVersion':
        return getPlatformVersion();
      default:
        throw PlatformException(
          code: 'Unimplemented',
          details: 'csounddart for web doesn\'t implement \'${call.method}\'',
        );
    }
  }

  /// Returns a [String] containing the version of the platform.
  Future<String> getPlatformVersion() {
    final version = html.window.navigator.userAgent;
    return Future.value(version);
  }
}
